﻿init python:
    from copy import copy
    import random
    import time
    random.seed(time.time())
    class burger_client:
        def __init__(self, name, image, order, patience):
            self.name = name
            self.image = image
            self.order = order
            self.patience_init = patience
            self.patience = patience
        
    class burger_part:
        def __init__(self, image, thickness, bottom, cost):
            self.image = image
            self.thickness = thickness
            self.bottom = bottom
            self.cost = cost
            self.offset = 0
            self.flip = 1
            self.xpos = 0
        def nudge(self):
            self.flip = random.choice([-1,1])
            self.xpos = random.randint(-1,1)
    class burger_class:
        def __init__(self, ingredients, clients):
            self.ingredients = ingredients
            self.current = []
            self.clients = clients
            self.current_client = None
        def put(self, i):
            self.current.append(copy(i))
            self.set_offset(self.current)
            i.nudge()
        def reset(self):
            self.current = []
            self.current_offset = 0
        def orders_up(self):
            self.current = []
            self.current_client = []
        def set_offset(self, order):
            offset = 0
            for i in order:
                i.offset = (offset - i.bottom)
                offset += i.thickness
        def compare(self, order, burger):
            match_score = 0
            order_names = [i.name for i in order]
            burger_names = [i.name for i in burger]
            burger_copy = copy(burger)
            for a,b in zip(order, burger):
                if a == b:
                    match_score += 1
            return match_score
        def spawn_client(self):
            if self.current_client:
                if self.current_client.patience > 0:
                    self.current_client.patience -= 1
                    return
                else:
                    self.current_client = None
                    return

            renpy.notify(1)
            image = random.choice(self.clients)
            order = [copy(self.ingredients[0])]
            for i in range(random.randint(1,6)):
                order.append(copy(random.choice(self.ingredients)))
            order.append(copy(self.ingredients[-1]))
            self.set_offset(order)
            client = burger_client(image, image, order, random.randint(30,50))
            self.current_client = client
init:
    image burger_1 = Crop((0,0,32,32), "burger/burger.png")
    image burger_2 = Crop((32,0,32,32), "burger/burger.png")
    image burger_3 = Crop((64,0,32,32), "burger/burger.png")
    image burger_4 = Crop((96,0,32,32), "burger/burger.png")
    image burger_5 = Crop((0,32,32,32), "burger/burger.png")
    image burger_6 = Crop((32,32,32,32), "burger/burger.png")
    image burger_7 = Crop((64,32,32,32), "burger/burger.png")
    image burger_8 = Crop((96,32,32,32), "burger/burger.png")

screen burger_shop():
    modal True
    default g = burger_class(
        ingredients = [
            burger_part("burger_1", 5, 0, 1),
            burger_part("burger_2", 1, 3, 1),
            burger_part("burger_3", 1, 2, 1),
            burger_part("burger_4", 4, 0, 1),
            burger_part("burger_5", 1, 4, 1),
            burger_part("burger_6", 2, 2, 1),
            burger_part("burger_7", 2, 3, 1),
            burger_part("burger_8", 5, 0, 1),
        ],
        clients = [
            "client_1",
            "client_2",
            "client_3",
            "client_4",
            "client_5",
        ]
    )
    add "burger_bg"
    if g.current_client:
        fixed fit_first True:
            align .5,1.0
            add g.current_client.image
            bar value g.current_client.patience range g.current_client.patience_init xysize 400,20 align .5,.0 yoffset -40
            fixed:
                fit_first True at zoom(4, True)
                align 1.0,.0 xanchor 0.0
                for i in g.current_client.order:
                    button:
                        add i.image yoffset -i.offset xzoom i.flip
    timer 1 repeat True action Function(g.spawn_client)

    add "burger_desk"
    fixed:
        fit_first True at zoom(8, True)
        align .5,.6
        for i in g.current:
            button:
                focus_mask True
                add i.image yoffset -i.offset xzoom i.flip xoffset i.xpos
                action Function(i.nudge)
    
    hbox:
        align .5,.9
        at zoom(4, True)
        for i in g.ingredients:
            button:
                add i.image
                action Function(g.put, i)
    hbox spacing 600:
        align .5,.7
        button:
            add "burger_discard"
            action Function(g.reset)
        button:
            add "burger_orders_up"
            action Function(g.orders_up)

    vbox:
        if g.current_client:
            text str(len(g.current_client.order)) color "#000"

label burger_example:
    call screen burger_shop